IWasBlocking = {}

IWasBlocking.name = "IWasBlocking"
IWasBlocking.lockedUI = false


IWasBlocking.lastTimeWasBlocking = 0
IWasBlocking.lastTimeDodgeRollWhileBlocking = 0

IWasBlocking.lastTimeDrainStart = 0

IWasBlocking.defaults	= {
	["audible"]	= true,
	["soundEffect"] = "Duel_Boundary_Warning",
    ["exhilaratingDrain"] = tue,
    ["pucturingSweep"] = tue,
    ["bash"] = tue,
}


local sounds = {
    "No Sound Effect",
    "Justice_PickpocketFailed",
    "Dialog_Decline",
    "Ability_Ultimate_Ready_Sound",
    "Quest_Shared",
    "Champion_PointsCommitted",
    "GroupElection_Requested",
    "Duel_Boundary_Warning",
}

function IWasBlocking:Initialize()
  IWasBlocking.AddonMenu()

  EVENT_MANAGER:RegisterForUpdate(self.name.."TickUpdate", 1000/60, function(gameTimeMs) self.UpdateBlock() end)

  EVENT_MANAGER:RegisterForEvent(self.name.."CombatEventDogeRoll",  EVENT_COMBAT_EVENT, self.OnCombatEventDodgeRoll)
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventDogeRoll", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 28549) -- Dodge Roll
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventDogeRoll", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED) -- gained dodge roll

  EVENT_MANAGER:RegisterForEvent(self.name.."CombatEventDrainStart",  EVENT_COMBAT_EVENT, self.OnCombatEventDrainStart)
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventDrainStart", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 137259) -- Exhilarating Drain
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventDrainStart", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED_DURATION) -- gained dodge roll


  EVENT_MANAGER:RegisterForEvent(self.name.."CombatEventDrainEnd",  EVENT_COMBAT_EVENT, self.OnCombatEventDrainEnd)
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventDrainEnd", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 137259) -- Exhilarating Drain
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventDrainEnd", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_FADED) -- drain faded



  EVENT_MANAGER:RegisterForEvent(self.name.."CombatEventJabStart",  EVENT_COMBAT_EVENT, self.OnCombatEventJabStart)
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventJabStart", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 26797) -- Jabs
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventJabStart", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED_DURATION) -- gained dodge roll


  EVENT_MANAGER:RegisterForEvent(self.name.."CombatEventJabEnd",  EVENT_COMBAT_EVENT, self.OnCombatEventJabEnd)
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventJabEnd", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 26797) -- Jabs
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventJabEnd", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_FADED) -- drain faded


  EVENT_MANAGER:RegisterForEvent(self.name.."CombatEventBashStart",  EVENT_COMBAT_EVENT, self.OnCombatEventBashStart)
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventBashStart", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 21970) -- bash
  EVENT_MANAGER:AddFilterForEvent(self.name.."CombatEventBashStart", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_DAMAGE) -- gained bash



  self.savedVariables = ZO_SavedVars:New("IWasBlockingSavedVariables", 1, nil, IWasBlocking.defaults)

  self.RestorePosition()
  
  IWasBlocking.CallbackManager = ZO_CallbackObject:New()
end

function IWasBlocking.OnAddOnLoaded(event, addonName)
  if addonName == IWasBlocking.name then
    IWasBlocking:Initialize()
  end
end


function IWasBlocking.UpdateBlock(gameTimeMs)
  local is_block_active = false
  
  local isRunning = IsShiftKeyDown() and IsPlayerMoving()
  local inCombat = IsUnitInCombat("player")
  local stamReg = 0
  local magReg = 0
  
  if inCombat then
    stamReg = GetPlayerStat(STAT_STAMINA_REGEN_COMBAT, STAT_BONUS_OPTION_APPLY_BONUS)
    magReg = GetPlayerStat(STAT_MAGICKA_REGEN_COMBAT, STAT_BONUS_OPTION_APPLY_BONUS)
  else
    stamReg = GetPlayerStat(STAT_STAMINA_REGEN_IDLE, STAT_BONUS_OPTION_APPLY_BONUS)
    magReg = GetPlayerStat(STAT_MAGICKA_REGEN_IDLE, STAT_BONUS_OPTION_APPLY_BONUS)
  end

  if IsBlockActive() and not isRunning and (stamReg == 0 or magReg == 0) then
    is_block_active = true
  end

    if is_block_active then
        IWasBlocking.lastTimeWasBlocking = GetGameTimeMilliseconds() -- last time block was active
        IWasBlocking.lastTimeDodgeRollWhileBlocking = 0
    end

    local showBasedOnUI = IWasBlocking.lockedUI
    local showBasedOnBlock = is_block_active

    local showBasedOnReBlock = false
    if GetGameTimeMilliseconds()-IWasBlocking.lastTimeDodgeRollWhileBlocking<2000 then
        showBasedOnReBlock = true
    end


    --IWasBlockingIndicator:SetHidden(not IWasBlocking.lockedUI and not is_block_active)
    if showBasedOnUI then
        IWasBlockingIndicatorLabel:SetText("MOVE ME")
        IWasBlockingIndicatorLabel:SetColor(58/255, 146/255, 255/255, 1.0)
        IWasBlockingIndicator:SetHidden(false)
    elseif showBasedOnBlock then
        IWasBlockingIndicatorLabel:SetText("BLOCKING")
        IWasBlockingIndicatorLabel:SetColor(58/255, 146/255, 255/255, 1.0)
        IWasBlockingIndicator:SetHidden(false)
    elseif showBasedOnReBlock then
        IWasBlockingIndicatorLabel:SetText("RE-BLOCK")
        IWasBlockingIndicatorLabel:SetColor(255/255, 0/255, 0/255, 1.0)
        IWasBlockingIndicator:SetHidden(false)

    else
        IWasBlockingIndicator:SetHidden(true)

    end



end



function IWasBlocking.OnCombatEventBashStart(eventCode,result,isError,abilityName,abilityGraphic,abilityActionSlotType,sourceName,sourceType,targetName,targetType,hitValue,powerType,damageType,combatEventLog,sourceUnitId,targetUnitId,abilityId)
    if IWasBlocking.savedVariables.bash then
        if sourceName == GetRawUnitName("player") then
       
            if GetGameTimeMilliseconds()-IWasBlocking.lastTimeWasBlocking<250 and not IsBlockActive() then --and not IsBlockActive() then

                IWasBlocking.lastTimeDodgeRollWhileBlocking = GetGameTimeMilliseconds()

                if IWasBlocking.savedVariables.audible then
                    PlaySound(IWasBlocking.savedVariables.soundEffect)

                end

            end

        end

    end
end




function IWasBlocking.OnCombatEventDodgeRoll(eventCode,result,isError,abilityName,abilityGraphic,abilityActionSlotType,sourceName,sourceType,targetName,targetType,hitValue,powerType,damageType,combatEventLog,sourceUnitId,targetUnitId,abilityId)
    if sourceName == GetRawUnitName("player") then

         if GetGameTimeMilliseconds()-IWasBlocking.lastTimeWasBlocking<250 then --and not IsBlockActive() then

            IWasBlocking.lastTimeDodgeRollWhileBlocking = GetGameTimeMilliseconds()

             if IWasBlocking.savedVariables.audible then
                 PlaySound(IWasBlocking.savedVariables.soundEffect)

             end

        end

    end
end





function IWasBlocking.OnCombatEventDrainStart(eventCode,result,isError,abilityName,abilityGraphic,abilityActionSlotType,sourceName,sourceType,targetName,targetType,hitValue,powerType,damageType,combatEventLog,sourceUnitId,targetUnitId,abilityId)
    if IWasBlocking.savedVariables.exhilaratingDrain then
        if sourceName == GetRawUnitName("player") then
            if GetGameTimeMilliseconds()-IWasBlocking.lastTimeWasBlocking<250 then
                IWasBlocking.lastTimeDrainStart = GetGameTimeMilliseconds()
            end
        end

    end
end





function IWasBlocking.OnCombatEventDrainEnd(eventCode,result,isError,abilityName,abilityGraphic,abilityActionSlotType,sourceName,sourceType,targetName,targetType,hitValue,powerType,damageType,combatEventLog,sourceUnitId,targetUnitId,abilityId)
    if IWasBlocking.savedVariables.exhilaratingDrain then
        if GetGameTimeMilliseconds() - IWasBlocking.lastTimeDrainStart < 2900 then -- only notify if drain ends early

            IWasBlocking.lastTimeDodgeRollWhileBlocking = GetGameTimeMilliseconds()

            if IWasBlocking.savedVariables.audible then
                PlaySound(IWasBlocking.savedVariables.soundEffect)
            end
        end
        IWasBlocking.lastTimeDrainStart = 0
    end
end







function IWasBlocking.OnCombatEventJabStart(eventCode,result,isError,abilityName,abilityGraphic,abilityActionSlotType,sourceName,sourceType,targetName,targetType,hitValue,powerType,damageType,combatEventLog,sourceUnitId,targetUnitId,abilityId)

    if IWasBlocking.savedVariables.pucturingSweep then

        if sourceName == GetRawUnitName("player") then
            if GetGameTimeMilliseconds()-IWasBlocking.lastTimeWasBlocking<250 then
                IWasBlocking.lastTimeDrainStart = GetGameTimeMilliseconds()
            end
        end

    end
end





function IWasBlocking.OnCombatEventJabEnd(eventCode,result,isError,abilityName,abilityGraphic,abilityActionSlotType,sourceName,sourceType,targetName,targetType,hitValue,powerType,damageType,combatEventLog,sourceUnitId,targetUnitId,abilityId)

    if IWasBlocking.savedVariables.pucturingSweep then
        if GetGameTimeMilliseconds() - IWasBlocking.lastTimeDrainStart < 700 then -- only notify if drain ends early

            IWasBlocking.lastTimeDodgeRollWhileBlocking = GetGameTimeMilliseconds()

            if IWasBlocking.savedVariables.audible then
                PlaySound(IWasBlocking.savedVariables.soundEffect)
            end
        end
        IWasBlocking.lastTimeDrainStart = 0
    end
end



function IWasBlocking.OnIndicatorMoveStop()
  IWasBlocking.savedVariables.left = IWasBlockingIndicator:GetLeft()
  IWasBlocking.savedVariables.top = IWasBlockingIndicator:GetTop()
end

function IWasBlocking.ResetPosition()
  IWasBlockingIndicator:ClearAnchors()
  IWasBlockingIndicator:SetAnchor(BOTTOM, GuiRoot, CENTER, 0, -40)
  IWasBlocking.OnIndicatorMoveStop()
end

function IWasBlocking.RestorePosition()
  local left = IWasBlocking.savedVariables.left
  local top = IWasBlocking.savedVariables.top
  if (left ~= nil and top ~= nil and left > 0 and top > 0) then
    if IWasBlockingIndicator:GetAnchor() ~= nil then
      IWasBlockingIndicator:ClearAnchors()
    end
    IWasBlockingIndicator:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top)
  else
    IWasBlocking.ResetPosition()
  end
end

function IWasBlocking.AddonMenu()
	local menuOptions = {
		type				 = "panel",
		name				 = IWasBlocking.name,
		displayName	 = IWasBlocking.name,
		author			 = IWasBlocking.author,
		version			 = IWasBlocking.version,
		slashCommand = "/iwb",
		registerForRefresh	= true,
		registerForDefaults = true,
	}

	local dataTable = {
		{
			type = "description",
			text = "I Was Blocking! Visible cue if you are blocking then lost it to game bug in U36.",
		},
		{
			type = "divider",
		},
		{
			type    = "checkbox",
			name    = "Lock UI (to move it)",
			default = false,
			getFunc = function() return IWasBlocking.lockedUI end,
			setFunc = function( newValue ) IWasBlocking.lockedUI = newValue; end,
		},

        {
			type = "checkbox",
			name = "Bash",
			tooltip = "Warns if you bash and drop block (this seems to happen somewhat randomly)",
			getFunc = function() return IWasBlocking.savedVariables.bash end,
			setFunc = function(value)
				if not value then
					IWasBlocking.savedVariables.bash = false
				else
					IWasBlocking.savedVariables.bash = true
				end
			end
		},



        {
			type = "checkbox",
			name = "Exhilarating Drain",
			tooltip = "This is not perfect, but attempts to warn when block canceling ExhDrain if you were blocking when started",
			getFunc = function() return IWasBlocking.savedVariables.exhilaratingDrain end,
			setFunc = function(value)
				if not value then
					IWasBlocking.savedVariables.exhilaratingDrain = false
				else
					IWasBlocking.savedVariables.exhilaratingDrain = true
				end
			end
		},

        {
			type = "checkbox",
			name = "Puncturing Sweep",
			tooltip = "This is not perfect, but attempts to warn when block canceling Puncturing Sweep if you were blocking when started",
			getFunc = function() return IWasBlocking.savedVariables.pucturingSweep end,
			setFunc = function(value)
				if not value then
					IWasBlocking.savedVariables.pucturingSweep = false
				else
					IWasBlocking.savedVariables.pucturingSweep = true
				end
			end
		},


        {
			type = "checkbox",
			name = "Audible Warning",
			tooltip = "Audible Warning to re-block",
			getFunc = function() return IWasBlocking.savedVariables.audible end,
			setFunc = function(value)
				if not value then
					IWasBlocking.savedVariables.audible = false
				else
					IWasBlocking.savedVariables.audible = true
				end
			end
		},
        {
            type = "dropdown",
            name = "Re-block warning sound effect",
            tooltip = "Sound to play when a re-block is needed",
            choices = sounds,
            getFunc = function() return IWasBlocking.savedVariables.soundEffect end,
            setFunc = function(value)
                IWasBlocking.savedVariables.soundEffect = value
                if value == "No Sound Effect" then
                else
                    PlaySound(value)
                end
            end,
        },


        {
			type    = "button",
			name    = "Reset to default position",
			func = function() IWasBlocking.ResetPosition()  end,
		},
	}
	LAM = LibAddonMenu2

	LAM:RegisterAddonPanel(IWasBlocking.name .. "Options", menuOptions )
	LAM:RegisterOptionControls(IWasBlocking.name .. "Options", dataTable )
end


EVENT_MANAGER:RegisterForEvent(IWasBlocking.name, EVENT_ADD_ON_LOADED, IWasBlocking.OnAddOnLoaded)

